.\"/*
.\" * Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
.\" * See https://llvm.org/LICENSE.txt for license information.
.\" * SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
.\" *
.\" */
.MS W 972 "The directive #pragma acc mirror is deprecated; use #pragma acc declare create instead"
.MS W 973 "The directive #pragma acc reflected is deprecated; use #pragma acc declare present"
.MS W 974 "The directive #pragma acc region is deprecated; use #pragma acc kernels instead"
.MS W 975 "The directive #pragma acc data region is deprecated; use #pragma acc data instead"
.MS W 976 "The directive #pragma acc for is deprecated; use #pragma acc loop instead"
.MS W 977 "The directive #pragma acc for kernel is deprecated; use #pragma acc loop instead"
.MS W 978 "The clause parallel is deprecated; use clause gang instead"
.MS W 979 "The directive #pragma acc region for is deprecated; use #pragma acc kernels loop instead"
.MS W 980 "The directive #pragma acc region loop is deprecated; use #pragma acc kernels loop instead"
.MS W 981 "The directive #pragma acc kernels for is deprecated; use #pragma acc kernels loop instead"
.MS W 982 "The directive #pragma acc deviceptr is deprecated; use #pragma acc declare deviceptr instead"
.MS W 983 "The directive #pragma acc parallel for is deprecated; use #pragma acc parallel loop instead"
.MS W 984 "The directive #pragma acc scalar region is deprecated; use #pragma acc serial instead"
.MS W 985 "The clause local is deprecated; use clause create instead"
.MS W 986 "The clause cache is deprecated; use directive #pragma acc cache instead"
.MS W 987 "The clause update host is deprecated; use separate update host directive after the region instead"
.MS W 988 "The clause update device is deprecated; use separate update device directive before the region instead"
.MS W 989 "The clause update in is deprecated; use separate update device directeve before the region instead"
.MS W 990 "The clause update out is deprecated; use update self instead"
.MS W 991 "The clause pnot is deprecated; use no_create instead"
.MS W 992 "The clause updatein is deprecated; use update device instead"
.MS W 993 "The clause updateout is deprecated; use update self instead"
.MS W 994 "The directive #pragma acc copy is deprecated; use #pragma acc declare copy instead"
.MS W 995 "The directive #pragma acc copyin is deprecated; use #pragma acc declare copyin instead"
.MS W 996 "The directive #pragma acc copyout is deprecated; use #pragma acc declare copyout instead"
.MS W 997 "The directive #pragma acc device_resident is deprecated; use #pragma acc declare device_resident instead"
.MS W 998 "The directive #pragma acc for host is deprecated; no OpenACC equivalent"
.MS W 999 "The directive #pragma acc loop kernel is deprecated; no OpenACC equivalent"
.MS S 1000 "Call in OpenACC region to procedure '$' which has no acc routine information"
.MS S 1001 "All selected compute capabilities were disabled (see -Minfo)"
.MS S 1002 "Reduction type not supported for this variable datatype - $"
.MS W 1003 "Lambda capture by reference not supported in Accellerated region"
.MS W 1004 "Lambda capture 'this' by reference not supported in Accellerated region"
.MS W 1005 "The clause unroll is deprecated; no OpenACC equivalent"
.MS W 1006 "The clause mirror is deprecated; no OpenACC equivalent"
.MS W 1007 "The clause host is deprecated; no OpenACC equivalent"
.\" Skipping ahead to 1011 to keep the same numbers as the fortran front-end.
.MS S 1011 "Device variable cannot be THREADPRIVATE - $"
.MS S 1012 "Threadprivate variables are not supported in acc routine - $"
.MS S 1013 "Static Threadprivate variables are not supported - $"
.MS S 1014 "Global Threadprivate variables are not supported - $"
.\" skipping to keep same numbers as Fortran front-end
.MS S 1100 "Cannot collapse non-tightly-nested loops"
.MS F 1015 "No shape directive is defined in structure $"
.MS F 1016 "No shape name $ is defined in structure $"
.MS F 1017 "arrays/pointers appearing in the OpenACC shape and policy directives must be a member of current aggregate type"
.MS F 1018 "Only one unnamed Shape directive is allowed in one aggregate type (struct/union)"
.MS F 1019 "Type clause must be used to specified structure type when Shape/Policy is defined outside (struct/union/class) definition"
.MS F 1020 "Data-Type appearing in type clause cannot be found"
.MS F 1021 "Data-Type appearing in type clause must be struct/union type"
.MS F 1022 "Duplicated shape names $ are defined for structure/union/class $"
.MS F 1023 "Duplicated policy names $ are defined for structure/union/class $"
.MS F 1024 "Type clause is not allowed within structure/union/class definition"
.MS F 1025 "The number of dimension section descriptions doesn't match member $ which requires $ dimensions"
.MS F 1026 "Pointers appearing within relative clause must be their sibling members"
.MS F 1027 "As motion clauses, only create, copyin, copyout, copy, update, and deviceptr are allowed in policy directive"
.MS F 1028 "The variable $ doesn't have predefined policy $ available"
.MS F 1029 "The variable $ using policy $ is not a structure-based type"
.MS F 1030 "Policy motion $ is not allowed in $ directive"
.MS W 1031 "The directive #pragma acc create is deprecated; use #pragma acc declare create instead"
.MS W 1032 "The directive #pragma acc present is deprecated; use #pragma acc declare present instead"
.MS W 1033 "The directive #pragma acc link is deprecated; use #pragma acc declare link instead"
.MS F 1034 "Only signed/unsigned 32 bits and 64 bits integer variables are allowed in bound expression. $ is is not such variable"
.MS F 1035 "Only integer sibling members and global variables are allowed in bound expression. $ is is neither of them."
.MS F 1036 "No global variable named $ has been defined"
.MS F 1037 "Default clause can only contain include and exclude keyword."
.MS W 1038 "COPY clause on a dummy variable with INTENT(IN) attribute demoted to COPYIN - $"
.MS S 1039 "OpenACC data clause expected after $"
.MS S 1040 "OpenACC $ data clause may not follow a device_type clause."
.MS S 1041 "OpenACC $ clause may not follow a device_type clause."
.MS W 1042 "acc loop vector clause ignored because of inner vector loop."
Nested acc loop vector directives will not be honored if the loops cannot be
effectively collapsed or tiled.
.MS W 1043 "acc loop worker clause ignored because of inner worker loop."
Nested acc loop worker directives will not be honored if the loops cannot be
effectively collapsed or tiled.
.MS S 1044 "acc loop gang not allowed in an acc routine($) procedure."
.MS S 1045 "call to acc routine(gang$) procedure not allowed in acc loop $."
.MS S 1046 "OpenACC compute region ignored: no parallel kernels found."
.MS S 1047 "Inner collapsed loop bounds are not invariant in outer loop."
